MinGW: update tests to handle a native eol of crlf
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
20
21 # Test the binaries we have just built.  The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25         # We allow tests to override this, in case they want to run tests
26         # outside of t/, e.g. for running tests on the test library
27         # itself.
28         TEST_DIRECTORY=$(pwd)
29 else
30         # ensure that TEST_DIRECTORY is an absolute path so that it
31         # is valid even if the current working directory is changed
32         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
33 fi
34 if test -z "$TEST_OUTPUT_DIRECTORY"
35 then
36         # Similarly, override this to store the test-results subdir
37         # elsewhere
38         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39 fi
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
45 if test $? != 1
46 then
47         echo >&2 'error: you do not seem to have built git yet.'
48         exit 1
49 fi
50
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
53
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
57 done,*)
58         # do not redirect again
59         ;;
60 *' --tee '*|*' --va'*)
61         mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62         BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63         (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64          echo $? > $BASE.exit) | tee $BASE.out
65         test "$(cat $BASE.exit)" = 0
66         exit
67         ;;
68 esac
69
70 # For repeatability, reset the environment to known value.
71 LANG=C
72 LC_ALL=C
73 PAGER=cat
74 TZ=UTC
75 TERM=dumb
76 export LANG LC_ALL PAGER TERM TZ
77 EDITOR=:
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
80 # deriving from the command substitution clustered with the other
81 # ones.
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83         my @env = keys %ENV;
84         my $ok = join("|", qw(
85                 TRACE
86                 DEBUG
87                 USE_LOOKUP
88                 TEST
89                 .*_TEST
90                 PROVE
91                 VALGRIND
92                 UNZIP
93                 PERF_
94                 CURL_VERBOSE
95         ));
96         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97         print join("\n", @vars);
98 ')
99 unset XDG_CONFIG_HOME
100 unset GITPERLLIB
101 GIT_AUTHOR_EMAIL=author@example.com
102 GIT_AUTHOR_NAME='A U Thor'
103 GIT_COMMITTER_EMAIL=committer@example.com
104 GIT_COMMITTER_NAME='C O Mitter'
105 GIT_MERGE_VERBOSITY=5
106 GIT_MERGE_AUTOEDIT=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110 export EDITOR
111
112 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
113 then
114         GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
115         export GIT_INDEX_VERSION
116 fi
117
118 # Add libc MALLOC and MALLOC_PERTURB test
119 # only if we are not executing the test with valgrind
120 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
121    test -n "$TEST_NO_MALLOC_CHECK"
122 then
123         setup_malloc_check () {
124                 : nothing
125         }
126         teardown_malloc_check () {
127                 : nothing
128         }
129 else
130         setup_malloc_check () {
131                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
132                 export MALLOC_CHECK_ MALLOC_PERTURB_
133         }
134         teardown_malloc_check () {
135                 unset MALLOC_CHECK_ MALLOC_PERTURB_
136         }
137 fi
138
139 # Protect ourselves from common misconfiguration to export
140 # CDPATH into the environment
141 unset CDPATH
142
143 unset GREP_OPTIONS
144 unset UNZIP
145
146 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
147 1|2|true)
148         echo "* warning: Some tests will not work if GIT_TRACE" \
149                 "is set as to trace on STDERR ! *"
150         echo "* warning: Please set GIT_TRACE to something" \
151                 "other than 1, 2 or true ! *"
152         ;;
153 esac
154
155 # Convenience
156 #
157 # A regexp to match 5 and 40 hexdigits
158 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
159 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
160
161 # Zero SHA-1
162 _z40=0000000000000000000000000000000000000000
163
164 # Line feed
165 LF='
166 '
167
168 export _x05 _x40 _z40 LF
169
170 # Each test should start with something like this, after copyright notices:
171 #
172 # test_description='Description of this test...
173 # This test checks if command xyzzy does the right thing...
174 # '
175 # . ./test-lib.sh
176 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
177                 TERM=$ORIGINAL_TERM &&
178                 export TERM &&
179                 [ -t 1 ] &&
180                 tput bold >/dev/null 2>&1 &&
181                 tput setaf 1 >/dev/null 2>&1 &&
182                 tput sgr0 >/dev/null 2>&1
183         ) &&
184         color=t
185
186 while test "$#" -ne 0
187 do
188         case "$1" in
189         -d|--d|--de|--deb|--debu|--debug)
190                 debug=t; shift ;;
191         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
192                 immediate=t; shift ;;
193         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
194                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
195         -r)
196                 shift; test "$#" -ne 0 || {
197                         echo 'error: -r requires an argument' >&2;
198                         exit 1;
199                 }
200                 run_list=$1; shift ;;
201         --run=*)
202                 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
203         -h|--h|--he|--hel|--help)
204                 help=t; shift ;;
205         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
206                 verbose=t; shift ;;
207         --verbose-only=*)
208                 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
209                 shift ;;
210         -q|--q|--qu|--qui|--quie|--quiet)
211                 # Ignore --quiet under a TAP::Harness. Saying how many tests
212                 # passed without the ok/not ok details is always an error.
213                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
214         --with-dashes)
215                 with_dashes=t; shift ;;
216         --no-color)
217                 color=; shift ;;
218         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
219                 valgrind=memcheck
220                 shift ;;
221         --valgrind=*)
222                 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
223                 shift ;;
224         --valgrind-only=*)
225                 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
226                 shift ;;
227         --tee)
228                 shift ;; # was handled already
229         --root=*)
230                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
231                 shift ;;
232         *)
233                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
234         esac
235 done
236
237 if test -n "$valgrind_only"
238 then
239         test -z "$valgrind" && valgrind=memcheck
240         test -z "$verbose" && verbose_only="$valgrind_only"
241 elif test -n "$valgrind"
242 then
243         verbose=t
244 fi
245
246 if test -n "$color"
247 then
248         say_color () {
249                 (
250                 TERM=$ORIGINAL_TERM
251                 export TERM
252                 case "$1" in
253                 error)
254                         tput bold; tput setaf 1;; # bold red
255                 skip)
256                         tput setaf 4;; # blue
257                 warn)
258                         tput setaf 3;; # brown/yellow
259                 pass)
260                         tput setaf 2;; # green
261                 info)
262                         tput setaf 6;; # cyan
263                 *)
264                         test -n "$quiet" && return;;
265                 esac
266                 shift
267                 printf "%s" "$*"
268                 tput sgr0
269                 echo
270                 )
271         }
272 else
273         say_color() {
274                 test -z "$1" && test -n "$quiet" && return
275                 shift
276                 printf "%s\n" "$*"
277         }
278 fi
279
280 error () {
281         say_color error "error: $*"
282         GIT_EXIT_OK=t
283         exit 1
284 }
285
286 say () {
287         say_color info "$*"
288 }
289
290 test "${test_description}" != "" ||
291 error "Test script did not set test_description."
292
293 if test "$help" = "t"
294 then
295         printf '%s\n' "$test_description"
296         exit 0
297 fi
298
299 exec 5>&1
300 exec 6<&0
301 if test "$verbose" = "t"
302 then
303         exec 4>&2 3>&1
304 else
305         exec 4>/dev/null 3>/dev/null
306 fi
307
308 test_failure=0
309 test_count=0
310 test_fixed=0
311 test_broken=0
312 test_success=0
313
314 test_external_has_tap=0
315
316 die () {
317         code=$?
318         if test -n "$GIT_EXIT_OK"
319         then
320                 exit $code
321         else
322                 echo >&5 "FATAL: Unexpected exit with code $code"
323                 exit 1
324         fi
325 }
326
327 GIT_EXIT_OK=
328 trap 'die' EXIT
329
330 # The user-facing functions are loaded from a separate file so that
331 # test_perf subshells can have them too
332 . "$TEST_DIRECTORY/test-lib-functions.sh"
333
334 # You are not expected to call test_ok_ and test_failure_ directly, use
335 # the test_expect_* functions instead.
336
337 test_ok_ () {
338         test_success=$(($test_success + 1))
339         say_color "" "ok $test_count - $@"
340 }
341
342 test_failure_ () {
343         test_failure=$(($test_failure + 1))
344         say_color error "not ok $test_count - $1"
345         shift
346         printf '%s\n' "$*" | sed -e 's/^/#      /'
347         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
348 }
349
350 test_known_broken_ok_ () {
351         test_fixed=$(($test_fixed+1))
352         say_color error "ok $test_count - $@ # TODO known breakage vanished"
353 }
354
355 test_known_broken_failure_ () {
356         test_broken=$(($test_broken+1))
357         say_color warn "not ok $test_count - $@ # TODO known breakage"
358 }
359
360 test_debug () {
361         test "$debug" = "" || eval "$1"
362 }
363
364 match_pattern_list () {
365         arg="$1"
366         shift
367         test -z "$*" && return 1
368         for pattern_
369         do
370                 case "$arg" in
371                 $pattern_)
372                         return 0
373                 esac
374         done
375         return 1
376 }
377
378 match_test_selector_list () {
379         title="$1"
380         shift
381         arg="$1"
382         shift
383         test -z "$1" && return 0
384
385         # Both commas and whitespace are accepted as separators.
386         OLDIFS=$IFS
387         IFS='   ,'
388         set -- $1
389         IFS=$OLDIFS
390
391         # If the first selector is negative we include by default.
392         include=
393         case "$1" in
394                 !*) include=t ;;
395         esac
396
397         for selector
398         do
399                 orig_selector=$selector
400
401                 positive=t
402                 case "$selector" in
403                         !*)
404                                 positive=
405                                 selector=${selector##?}
406                                 ;;
407                 esac
408
409                 test -z "$selector" && continue
410
411                 case "$selector" in
412                         *-*)
413                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
414                                 then
415                                         echo "error: $title: invalid non-numeric in range" \
416                                                 "start: '$orig_selector'" >&2
417                                         exit 1
418                                 fi
419                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
420                                 then
421                                         echo "error: $title: invalid non-numeric in range" \
422                                                 "end: '$orig_selector'" >&2
423                                         exit 1
424                                 fi
425                                 ;;
426                         *)
427                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
428                                 then
429                                         echo "error: $title: invalid non-numeric in test" \
430                                                 "selector: '$orig_selector'" >&2
431                                         exit 1
432                                 fi
433                 esac
434
435                 # Short cut for "obvious" cases
436                 test -z "$include" && test -z "$positive" && continue
437                 test -n "$include" && test -n "$positive" && continue
438
439                 case "$selector" in
440                         -*)
441                                 if test $arg -le ${selector#-}
442                                 then
443                                         include=$positive
444                                 fi
445                                 ;;
446                         *-)
447                                 if test $arg -ge ${selector%-}
448                                 then
449                                         include=$positive
450                                 fi
451                                 ;;
452                         *-*)
453                                 if test ${selector%%-*} -le $arg \
454                                         && test $arg -le ${selector#*-}
455                                 then
456                                         include=$positive
457                                 fi
458                                 ;;
459                         *)
460                                 if test $arg -eq $selector
461                                 then
462                                         include=$positive
463                                 fi
464                                 ;;
465                 esac
466         done
467
468         test -n "$include"
469 }
470
471 maybe_teardown_verbose () {
472         test -z "$verbose_only" && return
473         exec 4>/dev/null 3>/dev/null
474         verbose=
475 }
476
477 last_verbose=t
478 maybe_setup_verbose () {
479         test -z "$verbose_only" && return
480         if match_pattern_list $test_count $verbose_only
481         then
482                 exec 4>&2 3>&1
483                 # Emit a delimiting blank line when going from
484                 # non-verbose to verbose.  Within verbose mode the
485                 # delimiter is printed by test_expect_*.  The choice
486                 # of the initial $last_verbose is such that before
487                 # test 1, we do not print it.
488                 test -z "$last_verbose" && echo >&3 ""
489                 verbose=t
490         else
491                 exec 4>/dev/null 3>/dev/null
492                 verbose=
493         fi
494         last_verbose=$verbose
495 }
496
497 maybe_teardown_valgrind () {
498         test -z "$GIT_VALGRIND" && return
499         GIT_VALGRIND_ENABLED=
500 }
501
502 maybe_setup_valgrind () {
503         test -z "$GIT_VALGRIND" && return
504         if test -z "$valgrind_only"
505         then
506                 GIT_VALGRIND_ENABLED=t
507                 return
508         fi
509         GIT_VALGRIND_ENABLED=
510         if match_pattern_list $test_count $valgrind_only
511         then
512                 GIT_VALGRIND_ENABLED=t
513         fi
514 }
515
516 test_eval_ () {
517         # This is a separate function because some tests use
518         # "return" to end a test_expect_success block early.
519         eval </dev/null >&3 2>&4 "$*"
520 }
521
522 test_run_ () {
523         test_cleanup=:
524         expecting_failure=$2
525         setup_malloc_check
526         test_eval_ "$1"
527         eval_ret=$?
528         teardown_malloc_check
529
530         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
531         then
532                 setup_malloc_check
533                 test_eval_ "$test_cleanup"
534                 teardown_malloc_check
535         fi
536         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
537         then
538                 echo ""
539         fi
540         return "$eval_ret"
541 }
542
543 test_start_ () {
544         test_count=$(($test_count+1))
545         maybe_setup_verbose
546         maybe_setup_valgrind
547 }
548
549 test_finish_ () {
550         echo >&3 ""
551         maybe_teardown_valgrind
552         maybe_teardown_verbose
553 }
554
555 test_skip () {
556         to_skip=
557         skipped_reason=
558         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
559         then
560                 to_skip=t
561                 skipped_reason="GIT_SKIP_TESTS"
562         fi
563         if test -z "$to_skip" && test -n "$test_prereq" &&
564            ! test_have_prereq "$test_prereq"
565         then
566                 to_skip=t
567
568                 of_prereq=
569                 if test "$missing_prereq" != "$test_prereq"
570                 then
571                         of_prereq=" of $test_prereq"
572                 fi
573                 skipped_reason="missing $missing_prereq${of_prereq}"
574         fi
575         if test -z "$to_skip" && test -n "$run_list" &&
576                 ! match_test_selector_list '--run' $test_count "$run_list"
577         then
578                 to_skip=t
579                 skipped_reason="--run"
580         fi
581
582         case "$to_skip" in
583         t)
584                 say_color skip >&3 "skipping test: $@"
585                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
586                 : true
587                 ;;
588         *)
589                 false
590                 ;;
591         esac
592 }
593
594 # stub; perf-lib overrides it
595 test_at_end_hook_ () {
596         :
597 }
598
599 test_done () {
600         GIT_EXIT_OK=t
601
602         if test -z "$HARNESS_ACTIVE"
603         then
604                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
605                 mkdir -p "$test_results_dir"
606                 base=${0##*/}
607                 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
608
609                 cat >>"$test_results_path" <<-EOF
610                 total $test_count
611                 success $test_success
612                 fixed $test_fixed
613                 broken $test_broken
614                 failed $test_failure
615
616                 EOF
617         fi
618
619         if test "$test_fixed" != 0
620         then
621                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
622         fi
623         if test "$test_broken" != 0
624         then
625                 say_color warn "# still have $test_broken known breakage(s)"
626         fi
627         if test "$test_broken" != 0 || test "$test_fixed" != 0
628         then
629                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
630                 msg="remaining $test_remaining test(s)"
631         else
632                 test_remaining=$test_count
633                 msg="$test_count test(s)"
634         fi
635         case "$test_failure" in
636         0)
637                 # Maybe print SKIP message
638                 if test -n "$skip_all" && test $test_count -gt 0
639                 then
640                         error "Can't use skip_all after running some tests"
641                 fi
642                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
643
644                 if test $test_external_has_tap -eq 0
645                 then
646                         if test $test_remaining -gt 0
647                         then
648                                 say_color pass "# passed all $msg"
649                         fi
650                         say "1..$test_count$skip_all"
651                 fi
652
653                 test -d "$remove_trash" &&
654                 cd "$(dirname "$remove_trash")" &&
655                 rm -rf "$(basename "$remove_trash")"
656
657                 test_at_end_hook_
658
659                 exit 0 ;;
660
661         *)
662                 if test $test_external_has_tap -eq 0
663                 then
664                         say_color error "# failed $test_failure among $msg"
665                         say "1..$test_count"
666                 fi
667
668                 exit 1 ;;
669
670         esac
671 }
672
673 if test -n "$valgrind"
674 then
675         make_symlink () {
676                 test -h "$2" &&
677                 test "$1" = "$(readlink "$2")" || {
678                         # be super paranoid
679                         if mkdir "$2".lock
680                         then
681                                 rm -f "$2" &&
682                                 ln -s "$1" "$2" &&
683                                 rm -r "$2".lock
684                         else
685                                 while test -d "$2".lock
686                                 do
687                                         say "Waiting for lock on $2."
688                                         sleep 1
689                                 done
690                         fi
691                 }
692         }
693
694         make_valgrind_symlink () {
695                 # handle only executables, unless they are shell libraries that
696                 # need to be in the exec-path.
697                 test -x "$1" ||
698                 test "# " = "$(head -c 2 <"$1")" ||
699                 return;
700
701                 base=$(basename "$1")
702                 symlink_target=$GIT_BUILD_DIR/$base
703                 # do not override scripts
704                 if test -x "$symlink_target" &&
705                     test ! -d "$symlink_target" &&
706                     test "#!" != "$(head -c 2 < "$symlink_target")"
707                 then
708                         symlink_target=../valgrind.sh
709                 fi
710                 case "$base" in
711                 *.sh|*.perl)
712                         symlink_target=../unprocessed-script
713                 esac
714                 # create the link, or replace it if it is out of date
715                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
716         }
717
718         # override all git executables in TEST_DIRECTORY/..
719         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
720         mkdir -p "$GIT_VALGRIND"/bin
721         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
722         do
723                 make_valgrind_symlink $file
724         done
725         # special-case the mergetools loadables
726         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
727         OLDIFS=$IFS
728         IFS=:
729         for path in $PATH
730         do
731                 ls "$path"/git-* 2> /dev/null |
732                 while read file
733                 do
734                         make_valgrind_symlink "$file"
735                 done
736         done
737         IFS=$OLDIFS
738         PATH=$GIT_VALGRIND/bin:$PATH
739         GIT_EXEC_PATH=$GIT_VALGRIND/bin
740         export GIT_VALGRIND
741         GIT_VALGRIND_MODE="$valgrind"
742         export GIT_VALGRIND_MODE
743         GIT_VALGRIND_ENABLED=t
744         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
745         export GIT_VALGRIND_ENABLED
746 elif test -n "$GIT_TEST_INSTALLED"
747 then
748         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
749         error "Cannot run git from $GIT_TEST_INSTALLED."
750         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
751         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
752 else # normal case, use ../bin-wrappers only unless $with_dashes:
753         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
754         if ! test -x "$git_bin_dir/git"
755         then
756                 if test -z "$with_dashes"
757                 then
758                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
759                 fi
760                 with_dashes=t
761         fi
762         PATH="$git_bin_dir:$PATH"
763         GIT_EXEC_PATH=$GIT_BUILD_DIR
764         if test -n "$with_dashes"
765         then
766                 PATH="$GIT_BUILD_DIR:$PATH"
767         fi
768 fi
769 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
770 GIT_CONFIG_NOSYSTEM=1
771 GIT_ATTR_NOSYSTEM=1
772 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
773
774 if test -z "$GIT_TEST_CMP"
775 then
776         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
777         then
778                 GIT_TEST_CMP="$DIFF -c"
779         else
780                 GIT_TEST_CMP="$DIFF -u"
781         fi
782 fi
783
784 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
785 export GITPERLLIB
786 test -d "$GIT_BUILD_DIR"/templates/blt || {
787         error "You haven't built things yet, have you?"
788 }
789
790 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
791 then
792         echo >&2 'You need to build test-chmtime:'
793         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
794         exit 1
795 fi
796
797 # Test repository
798 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
799 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
800 case "$TRASH_DIRECTORY" in
801 /*) ;; # absolute path is good
802  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
803 esac
804 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
805 rm -fr "$TRASH_DIRECTORY" || {
806         GIT_EXIT_OK=t
807         echo >&5 "FATAL: Cannot prepare test area"
808         exit 1
809 }
810
811 HOME="$TRASH_DIRECTORY"
812 export HOME
813
814 if test -z "$TEST_NO_CREATE_REPO"
815 then
816         test_create_repo "$TRASH_DIRECTORY"
817 else
818         mkdir -p "$TRASH_DIRECTORY"
819 fi
820 # Use -P to resolve symlinks in our working directory so that the cwd
821 # in subprocesses like git equals our $PWD (for pathname comparisons).
822 cd -P "$TRASH_DIRECTORY" || exit 1
823
824 this_test=${0##*/}
825 this_test=${this_test%%-*}
826 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
827 then
828         say_color info >&3 "skipping test $this_test altogether"
829         skip_all="skip all tests in $this_test"
830         test_done
831 fi
832
833 # Provide an implementation of the 'yes' utility
834 yes () {
835         if test $# = 0
836         then
837                 y=y
838         else
839                 y="$*"
840         fi
841
842         while echo "$y"
843         do
844                 :
845         done
846 }
847
848 # Fix some commands on Windows
849 case $(uname -s) in
850 *MINGW*)
851         # Windows has its own (incompatible) sort and find
852         sort () {
853                 /usr/bin/sort "$@"
854         }
855         find () {
856                 /usr/bin/find "$@"
857         }
858         sum () {
859                 md5sum "$@"
860         }
861         # git sees Windows-style pwd
862         pwd () {
863                 builtin pwd -W
864         }
865         # no POSIX permissions
866         # backslashes in pathspec are converted to '/'
867         # exec does not inherit the PID
868         test_set_prereq MINGW
869         test_set_prereq NOT_CYGWIN
870         test_set_prereq NATIVE_CRLF
871         test_set_prereq SED_STRIPS_CR
872         test_set_prereq GREP_STRIPS_CR
873         GIT_TEST_CMP=mingw_test_cmp
874         ;;
875 *CYGWIN*)
876         test_set_prereq POSIXPERM
877         test_set_prereq EXECKEEPSPID
878         test_set_prereq NOT_MINGW
879         test_set_prereq CYGWIN
880         test_set_prereq SED_STRIPS_CR
881         test_set_prereq GREP_STRIPS_CR
882         ;;
883 *)
884         test_set_prereq POSIXPERM
885         test_set_prereq BSLASHPSPEC
886         test_set_prereq EXECKEEPSPID
887         test_set_prereq NOT_MINGW
888         test_set_prereq NOT_CYGWIN
889         ;;
890 esac
891
892 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
893 test -z "$NO_PERL" && test_set_prereq PERL
894 test -z "$NO_PYTHON" && test_set_prereq PYTHON
895 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
896 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
897
898 # Can we rely on git's output in the C locale?
899 if test -n "$GETTEXT_POISON"
900 then
901         GIT_GETTEXT_POISON=YesPlease
902         export GIT_GETTEXT_POISON
903         test_set_prereq GETTEXT_POISON
904 else
905         test_set_prereq C_LOCALE_OUTPUT
906 fi
907
908 # Use this instead of test_cmp to compare files that contain expected and
909 # actual output from git commands that can be translated.  When running
910 # under GETTEXT_POISON this pretends that the command produced expected
911 # results.
912 test_i18ncmp () {
913         test -n "$GETTEXT_POISON" || test_cmp "$@"
914 }
915
916 # Use this instead of "grep expected-string actual" to see if the
917 # output from a git command that can be translated either contains an
918 # expected string, or does not contain an unwanted one.  When running
919 # under GETTEXT_POISON this pretends that the command produced expected
920 # results.
921 test_i18ngrep () {
922         if test -n "$GETTEXT_POISON"
923         then
924             : # pretend success
925         elif test "x!" = "x$1"
926         then
927                 shift
928                 ! grep "$@"
929         else
930                 grep "$@"
931         fi
932 }
933
934 test_lazy_prereq PIPE '
935         # test whether the filesystem supports FIFOs
936         case $(uname -s) in
937         CYGWIN*)
938                 false
939                 ;;
940         *)
941                 rm -f testfifo && mkfifo testfifo
942                 ;;
943         esac
944 '
945
946 test_lazy_prereq SYMLINKS '
947         # test whether the filesystem supports symbolic links
948         ln -s x y && test -h y
949 '
950
951 test_lazy_prereq FILEMODE '
952         test "$(git config --bool core.filemode)" = true
953 '
954
955 test_lazy_prereq CASE_INSENSITIVE_FS '
956         echo good >CamelCase &&
957         echo bad >camelcase &&
958         test "$(cat CamelCase)" != good
959 '
960
961 test_lazy_prereq UTF8_NFD_TO_NFC '
962         # check whether FS converts nfd unicode to nfc
963         auml=$(printf "\303\244")
964         aumlcdiar=$(printf "\141\314\210")
965         >"$auml" &&
966         case "$(echo *)" in
967         "$aumlcdiar")
968                 true ;;
969         *)
970                 false ;;
971         esac
972 '
973
974 test_lazy_prereq AUTOIDENT '
975         sane_unset GIT_AUTHOR_NAME &&
976         sane_unset GIT_AUTHOR_EMAIL &&
977         git var GIT_AUTHOR_IDENT
978 '
979
980 test_lazy_prereq EXPENSIVE '
981         test -n "$GIT_TEST_LONG"
982 '
983
984 test_lazy_prereq USR_BIN_TIME '
985         test -x /usr/bin/time
986 '
987
988 # When the tests are run as root, permission tests will report that
989 # things are writable when they shouldn't be.
990 test -w / || test_set_prereq SANITY
991
992 GIT_UNZIP=${GIT_UNZIP:-unzip}
993 test_lazy_prereq UNZIP '
994         "$GIT_UNZIP" -v
995         test $? -ne 127
996 '